#include "TestCase.h"
#include "TestResult.h"
#include "TestCaller.h"

char* TestCaller_name(TestCallerRef self)
{
	return self->name;
}

void TestCaller_run(TestCallerRef self,TestResultRef result)
{
	TestCase cs;
	int i;
	for (i=0; i<self->numberOfFixtuers; i++) {
		cs.isa	= (TestImplementRef)&TestCaseImplement;
		cs.name	= self->fixtuers[i].name;
		cs.setUp= self->setUp;
		cs.tearDown	= self->tearDown;
		cs.runTest	= self->fixtuers[i].test;
		cs.isa->run(&cs,result);
	}
}

int TestCaller_countTestCases(TestCallerRef self)
{
	return self->numberOfFixtuers;
}

const TestImplement TestCallerImplement = {
	(TestTypeID)				TestCallerTypeID,
	(TestNameFunction)			TestCaller_name,
	(TestRunFunction)			TestCaller_run,
	(TestCountTestCasesFunction)TestCaller_countTestCases,
};
